<template>
    <div>
        <div class="selected-genre">
            <span>{{current?current.name: 'All'}}</span>
        </div>
        <ul class="genre-Menu">
            <li class="all-genre" @click="allGenreClick()">
                <span>All |</span>
            </li>
            <li class="li-genre-Menu" @click="genreClick(genre.name, genre.id)" v-for="genre in genres" :key="genre.id">
                <span>{{ genre.name }}</span>
            </li>
        </ul>
    </div>
</template>

<script>
    import store from "@/store";
    import {mapState, mapActions} from 'vuex'

    export default {
        name: 'GenreMenu',
        computed: mapState({
            genres: state => state.genre.genres,
            current: state => state.genre.current
        }),
        data() {
            return {
            }
        },
        created() {
            store.dispatch("genre/getAll")
        },
        methods:{
            genreClick(name, id) {
                this.$emit('selectedGenre', id);
                store.commit('genre/setGenre', {
                    name: name,
                    id: id
                });
            },
            allGenreClick(){
                this.$emit('allSelectedGenre');
                store.commit('genre/setGenre', null);
            }
        }
    }
</script>

<style scoped>

    .genre-Menu{
        list-style-type: none;
        display: flex;
        margin-top: -30px;
        margin-left: 380px;
        margin-block-end: 60px;
        color: #DCDCDC;
        font-size: 18px;
        cursor: pointer;
    }

    .li-genre-Menu{
        margin-right: 10px;
    }

    .selected-genre{
        margin-left: 130px;
        padding-top: 60px;
        font-size: 40px;
        color: #DCDCDC;
    }

    .all-genre{
        padding-right: 10px;
    }
</style>
